(*$AsciiOrdString: FULL_ORD *)

require "FULL_ORD";

structure AsciiOrdString: FULL_ORD =

(* ASCII STRINGS: CASE SENSITIVE LEXICAL ORDERING

Created by:     Dave Berry, Harlequin Ltd.
                daveb@harlequin.co.uk
                daveb@harlequin.com

Date:           30 Sep 1993

Maintenance:    mlworks-support@harlequin.co.uk
                mlworks-support@harlequin.com

DESCRIPTION

   MLWorks provides case-sensitive comparison functions for strings.


SEE ALSO

   LexOrdString, STRING, STRING_TYPE.


RCS LOG

$Log: AsciiOrdString.sml,v $
# Revision 1.1  1993/10/07  11:03:53  daveb
# Initial revision
#

*)

struct

(* TYPES *)

  type T = string


(* OBSERVERS *)

  fun lt x y = MLWorks.String.< (x, y)

  fun le x y = MLWorks.String.<= (x, y)

  fun gt x y = MLWorks.String.> (x, y)

  fun ge x y = MLWorks.String.>= (x, y)

end
