(*$ByteParse: PARSE GeneralTypes Instream *)

require "PARSE";
require "GeneralTypes";
require "Instream";

structure ByteParse: PARSE =

(* BYTES

Created by:     Dave Berry, Harlequin Ltd.
                daveb@harlequin.co.uk
                daveb@harlequin.com

Date:           30 Sep 1993

Maintenance:    mlworks-support@harlequin.co.uk
                mlworks-support@harlequin.com


RCS LOG

$Log: ByteParse.sml,v $
# Revision 1.1  1993/10/07  11:03:53  daveb
# Initial revision
#


*)

struct


(* TYPES *)

  type T = int


(* OBSERVERS *)

  val fixedWidth = true


(* CONVERTERS *)

  fun parse "" = Fail (None, "")
  |   parse s = OK (ord s, "")

  fun read i =
        case Instream.lookahead i of
          "" => Fail None
  	| s  => (Instream.input1 i; OK (ord s))
end
